<!DOCTYPE html>
<html lang="en">

<head>
    <meta charset="UTF-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <link rel="stylesheet" href="https://cdn.jsdelivr.net/npm/bootstrap@4.6.2/dist/css/bootstrap.min.css"
        integrity="sha384-xOolHFLEh07PJGoPkLv1IbcEPTNtaed2xpHsD9ESMhqIYd0nLMwNLD69Npy4HI+N" crossorigin="anonymous">
    <link rel="stylesheet" href="https://cdn.jsdelivr.net/npm/bootstrap-icons@1.10.5/font/bootstrap-icons.css">
    <script src="https://ajax.googleapis.com/ajax/libs/jquery/3.5.1/jquery.min.js"></script>
    <script src="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/js/bootstrap.min.js"></script>
    <link rel="preconnect" href="https://fonts.googleapis.com">
    <link rel="preconnect" href="https://fonts.gstatic.com" crossorigin>
    <link href="https://fonts.googleapis.com/css2?family=Squada+One&display=swap" rel="stylesheet">
    <link rel="stylesheet" href="style.css">
    <!-- data table -->
    <link rel="stylesheet" href="https://cdn.datatables.net/1.13.4/css/dataTables.bootstrap4.min.css">
    <script src="https://cdn.datatables.net/1.13.4/js/jquery.dataTables.min.js"></script>
    <script src="https://cdn.datatables.net/1.13.4/js/dataTables.bootstrap4.min.js"></script>

    <title>Cart</title>
</head>
<style>
    .ABeeZee {
        font-family: 'ABeeZee';
        font-style: normal;
        font-size: 18px;
    }

    .lexend-deca {
        font-family: 'Lexend Deca';
        font-style: normal;
    }

    .poppins {
        font-family: 'Poppins';
        font-style: normal;
    }

    .custom-bg-btn {
        background: #F6F7F8;
    }

    .custom-text-color {
        color: #1AC073;
    }

    .custom-inp-modal {
        background: #DFDEDE;
        color: #999999;
        margin: 25px 0;
    }

    .custom-method-payment {
        margin-left: 25px;
        padding: 10px 0;
        font-weight: 700;
    }

    .custom-btn-go-to-payment {
        background-color: #1AC073;
        color: white;
    }
</style>

<body>
    <div class="container-fluid col-lg-12">
        <!-- div header -->
        <div class="row">
            <div class="div-header col-lg-12 ">
                <div class="row col-lg-12">
                    <nav class="navbar navbar-expand-lg navbar-light d-flex justify-content-around  col-lg-12">
                        <a class="navbar-brand text-white" href="#">WHAT2EAT</a>
                        <button class="navbar-toggler" type="button" data-toggle="collapse"
                            data-target="#navbarSupportedContent" aria-controls="navbarSupportedContent"
                            aria-expanded="false" aria-label="Toggle navigation">
                            <span class="navbar-toggler-icon"></span>
                        </button>
                        <div class="collapse navbar-collapse" id="navbarSupportedContent">
                            <ul class="navbar-nav">
                                <div class="navbar-nav header-menu">

                                    <a class="nav-item nav-link mx-3 text-white" href="#">Home</a>
                                    <a class="nav-item nav-link mx-3 text-white" href="#">About</a>
                                    <a class="nav-item nav-link mx-3 text-white" href="#">Menu</a>
                                    <a class="nav-item nav-link mx-3 text-white" href="#">Blog</a>
                                    <a class="nav-item nav-link mx-3 text-white" href="#">Contact</a>
                                </div>
                                <div class="navbar-nav header-menu-icon">
                                    <i class="bi bi-search mx-3"></i>
                                    <i class="bi bi-cart2 mx-3"></i>
                                </div>
                            </ul>
                        </div>
                    </nav>
                </div>
                <div class=" header-main row d-flex align-items-center min-vh-100 ">
                    <div class="header-content col-lg-6 ">
                        <div class="col-lg-10 mx-auto mt-5">
                            <h1 class="text-white">Authentic Home food in UK</h1>
                            <p class="text-white">What2Eat is a courier service in which authentic home cook food is
                                delivered to a customer.</p>
                            <form class="example">
                                <input type="text" placeholder="Search food you love" name="search">
                                <button type="button">Search</button>
                            </form>
                        </div>
                    </div>
                    <div class="col-lg-6  header-picture">
                        <img src="cooking.man.header.png" alt="" width="600px" height="535px">
                    </div>
                </div>
            </div>
        </div>
        <!--end div header -->
        <!-- div card -->
        <div class="row">
            <div class="container">
                <div class="div-top-cart py-4 d-flex justify-content-center">
                    <p class="text-success mb-0"> Home</p>
                    <span class="mx-4">/</span>
                    <p class="text-success mb-0"> Trending</p>
                    <span class="mx-4">/</span>
                    <p class="text-success text-dark mb-0"> Famous Tandoor</p>
                </div>
                <!-- card -->
                <table id="cart-table" class="table" style="border-bottom: 1px solid #dee2e6;;">
                    <thead class="lexend-deca">
                        <tr>
                            <th scope="col" style="padding-left: 30px;">PRODUCT</th>
                            <th scope="col">PRICE</th>
                            <th scope="col">QTY</th>
                            <th scope="col">UNIT PRICE</th>
                        </tr>
                    </thead>
                    <tbody id="cart-tbody" class="poppins">
                        <tr>
                            <td class="d-flex">
                                <div class="col-lg-6">
                                    <img src="images/pizza1.png" alt="" width="130px">
                                </div>
                                <div class="col-lg-6">
                                    <h4>Pizza Name</h4>
                                </div>
                            </td>
                            <td class="col-1">
                                <p>$999</p>
                            </td>
                            <td class="col-1">
                                <div class="btn-group col-5">
                                    <button class="btn btn-secondary">-</button>
                                    <input type="number">
                                    <button class="btn btn-secondary">+</button>
                                </div>
                            </td>
                            <td>
                                <p>$999</p>
                            </td>
                        </tr>
                    </tbody>
                </table>
                <!-- Search Coupon & Bill -->
                <div class=" d-flex justify-content-between voucher-total mt-5">
                    <div class="col-md-8">
                        <div class="input-group ">
                            <div class="form-floating ">
                                <input id="inp-coupon" type="text" class="form-control py-4" placeholder="Voucher code">
                            </div>
                            <button id="btn-redeem"
                                class="btn bg-success input-group-text custom-btn-2 text-white ">Redeem</button>
                        </div>
                    </div>

                    <form id="form-total" class="col-md-4 lexend-deca">
                        <div class="row pb-3 justify-content-between">
                            <p>Subtotal</p>
                            <p id="sub-total">$998</p>
                        </div>
                        <div class="row pb-3 justify-content-between">
                            <p>Shipping fee</p>
                            <p id="shipping-fee">$20</p>
                        </div>
                        <div class="row pb-3 justify-content-between">
                            <p>Coupon</p>
                            <p id="coupon">NO</p>
                        </div>
                        <div class="row pb-3 justify-content-between">
                            <p>Phần trăm giảm giá</p>
                            <p id="discount-percent">0</p>
                        </div>
                        <hr class="pb-3">
                        <div class="row pb-3 justify-content-between">
                            <h4>TOTAL</h4>
                            <h4 id="total">$1018</h4>
                        </div>
                        <div class="row pb-3">
                            <button type="submit" class="form-control custom-btn-2">Check out</button>
                        </div>
                    </form>
                </div>

            </div>
        </div>
        <!-- end div card -->
        <!-- Modal -->
        <div id="payment-modal">
            <div id="create-payment-modal" class="modal fade" tabindex="-1">
                <div class="modal-dialog modal-lg">
                    <div class="modal-content lexend-deca">
                        <div class="modal-header">
                            <button class="close mr-4 custom-text-color" style="font-size: 35px;"
                                data-dismiss="modal">&times;</button>
                        </div>
                        <div class="modal-body">
                            <h1 class="modal-title text-center ABeeZee custom-text-color" style="font-size: 32px;">
                                Make Payment
                            </h1>
                            <div class="text-center mr-4">
                                <img src="./images/Stepper-payment-v2.0.png" id="stepper-payment">
                            </div>
                            <div>
                                <div class="row px-5 justify-content-around">
                                    <div class="form-group col-md-6">
                                        <input type="text" id="inp-firstname" placeholder="Firstname"
                                            class="form-control custom-inp-modal py-4">
                                        <input type="text" id="inp-email" placeholder="Email Address"
                                            class="form-control custom-inp-modal py-4">
                                        <div>
                                            <label class="custom-text-color">Select Method of Payment</label>
                                            <div class="form-check custom-method-payment">
                                                <input class="form-check-input" type="radio" name="flexRadioDefault"
                                                    id="flexRadioDefault1" value='CreditCard'>
                                                <label class="form-check-label" for="flexRadioDefault1">
                                                    <img src="./images/Group.png">
                                                    Credit Card Or Debit
                                                </label>
                                            </div>
                                            <div class="form-check custom-method-payment">
                                                <input class="form-check-input" type="radio" name="flexRadioDefault"
                                                    id="flexRadioDefault2" value='Paypal'>
                                                <label class="form-check-label" for="flexRadioDefault2">
                                                    <img src="./images/Paypal.png">
                                                    Paypal
                                                </label>
                                            </div>
                                            <div class="form-check custom-method-payment">
                                                <input class="form-check-input" type="radio" name="flexRadioDefault"
                                                    id="flexRadioDefault3" value='BankTransfer'>
                                                <label class="form-check-label" for="flexRadioDefault3">
                                                    <img src="./images/Bank.png">
                                                    Bank Transfer
                                                </label>
                                            </div>
                                        </div>
                                    </div>
                                    <div class="form-group col-md-6">
                                        <input type="text" id="inp-lastname" placeholder="Lastname"
                                            class="form-control custom-inp-modal py-4">
                                        <input type="text" id="inp-address" placeholder="Address for Delivery"
                                            class="form-control custom-inp-modal pt-4" style="padding-bottom: 90px;">
                                        <input type="text" id="inp-phone" placeholder="Mobile Phone"
                                            class="form-control custom-inp-modal py-4">
                                    </div>
                                </div>
                            </div>
                            <div class="modal-footer d-flex justify-content-center">
                                <button class="btn btn-lg px-5 custom-btn-go-to-payment" id="btn-payment">Go to
                                    payment</button>
                            </div>
                        </div>
                    </div>
                </div>
            </div>
        </div>
        <!-- success payment modal -->
        <div id="success-payment-modal">
            <div id="create-success-payment-modal" class="modal fade" tabindex="-1">
                <div class="modal-dialog modal-lg">
                    <div class="modal-content lexend-deca">
                        <div class="modal-header">
                            <button class="close mr-4 custom-text-color" style="font-size: 35px;"
                                data-dismiss="modal">&times;</button>
                        </div>
                        <div class="modal-body">
                            <h1 class="modal-title text-center ABeeZee custom-text-color" style="font-size: 32px;">
                                Make Payment
                            </h1>
                            <div class="text-center mr-4">
                                <img src="./images/Stepper-success-payment-v2.0.png">
                            </div>
                            <div class="">
                                <div class="row px-5 justify-content-center">
                                    <img src="./images/Success Icon.png Icon.png" alt="">
                                </div>
                                <h4 class="lexend-deca text-center">Success</h4>
                            </div>
                            <div class="modal-footer d-flex justify-content-center">
                                <button class="btn btn-lg custom-btn-go-to-payment" id="btn-success-payment"
                                    style="padding: 10px 80px;">
                                    Complete
                                </button>
                            </div>
                        </div>
                    </div>
                </div>
            </div>
        </div>
    </div>

    <!-- div footer section -->
    <div class="row text-center ">
        <div class="div-header col-lg-12 ">
            <nav class="navbar navbar-expand-lg navbar-light d-flex justify-content-around  col-lg-12">
                <a class="navbar-brand text-white" href="#">WHAT2EAT</a>
                <button class="navbar-toggler" type="button" data-toggle="collapse"
                    data-target="#navbarSupportedContent" aria-controls="navbarSupportedContent" aria-expanded="false"
                    aria-label="Toggle navigation">
                    <span class="navbar-toggler-icon"></span>
                </button>
                <div class="collapse navbar-collapse" id="navbarSupportedContent">
                    <ul class="navbar-nav">
                        <div class="navbar-nav header-menu">

                            <a class="nav-item nav-link mx-3 text-white" href="#">Home</a>
                            <a class="nav-item nav-link mx-3 text-white" href="#">About</a>
                            <a class="nav-item nav-link mx-3 text-white" href="#">Menu</a>
                            <a class="nav-item nav-link mx-3 text-white" href="#">Blog</a>
                            <a class="nav-item nav-link mx-3 text-white" href="#">Contact</a>
                        </div>
                        <div class="navbar-nav header-menu-icon">
                            <i class="bi bi-facebook"></i> &nbsp; &nbsp;
                            <i class="bi bi-instagram"></i>
                        </div>
                    </ul>
                </div>
            </nav>
            <hr class="bg-white" style="height: 1px;">
            <p class="text-white text-center">Copyright @2021 What2Eat</p>
        </div>
    </div>
    <!-- end div footer section -->
    </div>
</body>
<script>
    /*** REGION 1 - Global variables - Vùng khai báo biến, hằng số, tham số TOÀN CỤC */
    $(document).ready(function () {
        const gCOUPON_URL = 'https://food-ordering-fvo9.onrender.com/api/vouchers/'
        var gDiscountPercent;
        var gCouponObj = {
            id: "",
            voucherCode: "",
        };

        var gPizzaLocalStorage = localStorage.getItem("pizza-chosen").split("-&-");

        var gJsonObj = gPizzaLocalStorage.map(function (pizza) {
            return JSON.parse(pizza)
        });
        var gCart = handleStorage(gJsonObj);

        console.log(gCart)

        /*** REGION 2 - Vùng gán / thực thi sự kiện cho các elements */
        onPageLoading()
        //thực thi nút giảm số lượng pizza chọn:
        $("#cart-tbody").on("click", ".btn-minus", function () {
            onBtnMinusClick(this)
        });
        //thực thi nút tăng số lượng pizza chọn:
        $("#cart-tbody").on("click", ".btn-plus", function () {
            onBtnPlusClick(this)
        });

        //thực thi nút xóa pizza chọn:
        $("#cart-tbody").on("click", ".btn-delete-pizza", function () {
            onBtnDeletePizza(this);
        });

        //thực thi nút redeem:
        $(".voucher-total").on("click", "#btn-redeem", function () {
            var vVoucher = $("#inp-coupon").val().trim();
            onBtnRedeemClick(vVoucher);
        });

        //gán sự kiện submit cho form Bill, mở modal payment
        $('#form-total').on('submit', function (event) {
            event.preventDefault()
            $('#create-payment-modal').modal('show')
        });
        //thực thi sự kiên ấn nút go to payment trên modal:
        $("#create-payment-modal").on("click", "#btn-payment", function () {
            onBtnGoToPaymentClick();
        });

        //thực thi sự kiên ấn nút complete trên modal make payment succes:
        $("#create-success-payment-modal").on("click", "#btn-success-payment", function() {
            window.location.href = "Task 41.30.html";
        })
        /*** REGION 3 - Event handlers - Vùng khai báo các hàm xử lý sự kiện */
        function onPageLoading() {
            loadPizzaChosenIntoCartTable();
            loadBill();

        };
        //hàm nút giảm số lượng pizza chọn
        function onBtnMinusClick(paramBtn) {
            const vPizzaId = paramBtn.getAttribute('data-id');
            gCart.map(function (array) {
                if (array[0].id === vPizzaId) {
                    return array[1]--

                }
            });
            loadBill();
            loadPizzaChosenIntoCartTable();

        };
        //hàm nút tăng số lượng pizza chọn

        function onBtnPlusClick(paramBtn) {
            const vPizzaId = paramBtn.getAttribute('data-id');
            gCart.map(function (array) {
                if (array[0].id === vPizzaId) {
                    return array[1]++
                }
            });
            loadBill()
            loadPizzaChosenIntoCartTable();
        };

        //hàm xóa pizza đã chọn trong cart:
        function onBtnDeletePizza(paramBtn) {
            const vPizzaId = paramBtn.getAttribute('data-id');
            console.log(vPizzaId)
            gCart.map(function (array) {
                if (array[0].id === vPizzaId) {
                    localStorage.removeItem("gCart");
                }
            });
            loadPizzaChosenIntoCartTable();

        }
        function onBtnGoToPaymentClick() {
            //B1: đọc dữ liệu:
            var vOrderObj = getOrder();
            console.log(vOrderObj)
            //B2: validate dữ liệu:
            var vOrderValid = validate(vOrderObj);
            //B3: gọi API
            if (vOrderValid) {
                callApiToCreateOrder(vOrderObj);
            };
            //B4: hiển thị:
        }




        /*** REGION 4 - Common funtions - Vùng khai báo hàm dùng chung trong toàn bộ chương trình*/
        //hàm tạo danh sách pizza đã chọn:
        function createListCart(paramPizza, paramAmount) {
            return `
            <tr>
                            <td class="d-flex">
                                <div class="col-lg-6">
                                    <img src="${paramPizza.imageUrl}" alt="" width="130px">
                                </div>
                                <div class="col-lg-6">
                                    <h4>${paramPizza.name}</h4>
                                </div>
                            </td>
                            <td class="col-1">
                                <p class="real-price">${paramPizza.price * paramAmount}</p>
                            </td>
                            <td class="col-1">
                                <div class="btn-group col-6">
                                    <button class="btn btn-secondary btn-minus" data-id='${paramPizza.id}'>-</button>
                                    <button class="btn btn-outline-secondary text-dark btn-count-chosen">${paramAmount}</button>
                                     <button class="btn btn-secondary btn-plus" data-id='${paramPizza.id}'>+</button>
                                </div>
                            </div class="col-12">
                                    <small class="text-danger btn-delete-pizza" style="text-decoration: underline;" data-id='${paramPizza.id}'>Remove Item</small>
                                </div>
                              </td>
                            </td>
                            <td>
                                <p>$${paramPizza.price}</p>
                            </td>
                        </tr>
            `
        }
        //hàm xử lý storage => [[obj,số lần xuất hiện],...]
        // lọc được các phần tử (obj detail) có id giống nhau thành 1 mảng gồm[obj,số lần xuất hiện]
        //=>ra 1 mảng mới gồm các mảng phía trên
        function handleStorage(paramStorage) {
            return paramStorage.reduce((acc, value) => {
                const { data, map } = acc;
                const ind = map.get(value.id);
                if (map.has(value.id)) {
                    data[ind][1]++;//để tăng số đếm các phần tử giống nhau
                } else {
                    map.set(value.id, data.push([value, 1]) - 1);//? chưa hiểu lắm
                }
                return { data, map };
            }, {
                data: [], //để push các obj và số lần xuất hiện tương ứng
                map: new Map()//Map là tập hợp các cặp key-val (viết dạng key=>value), tương tự obj nhưng có thể nhận key ở mọi kiểu dữ liệu
            }).data
        };
        //hàm load danh sách pizza đã chọn vào table:
        function loadPizzaChosenIntoCartTable() {
            $("#cart-tbody").html("");
            gCart.map((arr) => {
                $('#cart-tbody').append(createListCart(arr[0], arr[1]))
            });
        };
        //hàm tính subtotal
        function calculateSubtotal() {
            var vPriceArr = Array.from($('.real-price'))
            return vPriceArr.reduce((ele, cur) => ele += parseFloat(cur.innerText), 0)
        };

        //hàm tính total = subtotal + shipping fee
        function calculateTotal(paramPercent) {
            return (calculateSubtotal() + 20) * (100 - paramPercent) / 100
        };
        function loadBill() {
            $('#sub-total').html(`$${calculateSubtotal()}`)
            $('#total').html(`$${calculateTotal(0)}`)
        };
        //hàm ấn nút redeem:
        function onBtnRedeemClick(paramVoucher) {
            $.ajax({
                url: `${gCOUPON_URL}?voucherCode=${paramVoucher}`,
                type: "GET",
                success: function (paramRes) {
                    gCouponObj = paramRes[0];
                    console.log(gCouponObj.id);
                    console.log(makeDetailsOrder())
                    handleVoucher(paramRes)
                },
                error: function (paramError) {
                    console.log(paramError)

                }

            });

            //hàm handle voucher:
            function handleVoucher(paramVoucher) {
                if (paramVoucher.length == 1) {
                    gDiscountPercent = paramVoucher[0].discount
                    alert(`Thông tin mã giảm giá gồm: ${JSON.stringify(paramVoucher[0])}`)
                    $('#coupon').html(`${paramVoucher[0].voucherCode}`)
                    $('#discount-percent').html(`${paramVoucher[0].discount}`)
                    $('#total').html(`$${calculateTotal(gDiscountPercent)}`)
                } else {
                    alert('Mã giảm giá không tồn tại')
                    gDiscountPercent = 0
                    $('#total').html(`$${calculateTotal(gDiscountPercent)}`)
                    $('#discount-percent').html(gDiscountPercent)
                    $('#coupon').html('NO')
                }
            }
        }
        //Go To Payment:
        //B1: đọc dữ liệu:
        function getOrder() {
            var vRadioCheckedVal = $('input[name=flexRadioDefault]:checked').val()
            return (
                {
                    firstName: $('#inp-firstname').val(),
                    lastName: $('#inp-lastname').val(),
                    email: $('#inp-email').val(),
                    address: $('#inp-address').val(),
                    phone: $('#inp-phone').val(),
                    // Payment method là 1 trong 3 giá trị: CreditCard - Paypal - BankTransfer
                    methodPayment: vRadioCheckedVal,
                    // Voucher id lấy giá trị id khi kiểm tra mã giảm giá (Xem cấu trúc phần (**))
                    voucherId: gCouponObj.id,//có đc obj từ callAPI nút redeem?
                    details: makeDetailsOrder()
                }
            )
        }

        //hàm tạo details({id món ăn, số lượng của món đó})
        function makeDetailsOrder() {
            return gCart.map(function (detailArr) {
                return (
                    {
                        foodId: detailArr[0].id,
                        quantity: detailArr[1]
                    }
                )
            });
        };
        //B2: validate dữ liệu:
        //hàm validate dữ liệu:
        function validate(paramOrderObj) {
            if (paramOrderObj.details.length == 0) {
                alert("Vui lòng chọn pizza!");
                return false;
            }
            if (paramOrderObj.firstname == "") {
                alert("Vui lòng nhập firstname!");
                return false;
            }
            if (paramOrderObj.lastname == "") {
                alert("Vui lòng nhập lastname!");
                return false;
            }
            if (paramOrderObj.email == "" || !validateEmail(paramOrderObj.email)) {
                alert("Vui lòng nhập email đúng định dạng!");
                return false;
            }
            if (paramOrderObj.address == "") {
                alert("Vui lòng nhập address!");
                return false;
            }
            if (paramOrderObj.phone == "" || !validatePhoneNumber(paramOrderObj.phone)) {
                alert("Vui lòng nhập số điện thoại đúng định dạng!");
                return false;
            }
            if (paramOrderObj.methodPayment == null) {
                alert("Vui lòng chọn hình thức thanh toán!");
                return false;
            }
            return true
        }
        //B3: gọi API
        function callApiToCreateOrder(paramOrderObj) {
            $.ajax({
                url: "https://food-ordering-fvo9.onrender.com/api" + "/orders/",
                type: "POST",
                contentType: "application/json",
                data: JSON.stringify(paramOrderObj),
                success: function (paramRes) {
                    console.log(paramRes);
                    handleCreateOrder(paramRes)

                },
                error: function (paramError) {
                    console.log(paramError);

                }
            });
        }
        //B4: xử lý khi call api thêm mới đơn hàng thành công
        function handleCreateOrder(paramRes) {
            console.log(paramRes)
            localStorage.clear()
            $('#create-payment-modal').modal('hide')
            $('#create-success-payment-modal').modal('show')
        }

        //hàm validate email
        function validateEmail(paramEmail) {
            var vRegexEmail = /^\w+([\.-]?\w+)*@\w+([\.-]?\w+)*(\.\w{2,3})+$/
            var vCheckedEmail = paramEmail.match(vRegexEmail);
            return vCheckedEmail
        };

        //hàm validate phone number:
        function validatePhoneNumber(paramPhoneNumber) {
            var vRegexPhoneNumber = /^[\+]?[(]?[0-9]{3}[)]?[-\s\.]?[0-9]{3}[-\s\.]?[0-9]{4,6}$/im
            var vCheckPhoneNumber = paramPhoneNumber.match(vRegexPhoneNumber);
            return vCheckPhoneNumber
        }

    });

</script>

</html>